import * as React from "react";
import { IImmutalbeList } from "../util/immutableUtil";
import { calendarType } from "./timeFn";
import { ICommonInterface } from "./calendar";
declare type Props = {
    field: string;
    excludeRotate?: string;
    disabled?: boolean;
    require?: boolean;
    rotate?: ICommonInterface["rotate"];
    style?: 1 | 2;
    time?: boolean;
    noInp?: boolean;
    defaultTime?: string;
    width?: number;
    placeholder?: string;
    ableClear?: boolean;
    initTime?: {
        time: string;
    };
    renderCallBack?: boolean;
    noChangeRotate?: boolean;
    valFormatt?: "number" | "string";
    clickBefore?: ICommonInterface["clickBack"];
    clickBack: ICommonInterface["clickBack"];
    matchTimeStr?: (field: string, value?: string) => boolean;
    children?: React.ReactNode;
};
declare type States = {
    preRotate: Props['rotate'];
    preInitTime: Props['initTime'];
    expand: boolean;
    pannelLastYear: IImmutalbeList<number>;
    selTimeArr: IImmutalbeList<ICommonInterface["showTimeObj"]>;
    showTimeArr: IImmutalbeList<ICommonInterface["showTimeObj"]>;
    calendarVal: string;
    rotate: ICommonInterface["rotate"];
    showViewArr: ("fadeIn" | "fadeOut")[];
};
declare type fixProps = {
    style: 1 | 2;
    time: boolean;
    noChangeRotate: boolean;
};
interface ICalendar {
    curTime: ICommonInterface["curTime"];
    fixProps: fixProps;
    changeBasicState: ICommonInterface["changeBasicState"];
    createFixProps(): fixProps;
    getShowViewArr(rotate: ICommonInterface["rotate"]): States["showViewArr"];
}
declare class Calendar extends React.PureComponent<Props, States> implements ICalendar {
    static defaultProps: {
        rotate: calendarType;
        style: number;
        defaultTime: string;
        width: number;
        excludeRotate: string;
        placeholder: string;
        valFormatt: string;
    };
    static getDerivedStateFromProps(nextProps: Props, preState: States): Partial<States> | null;
    eventId: string;
    curTime: {
        year: number;
        searson: number;
        month: number;
        day: number;
        hour: number;
        minute: number;
    };
    fixProps: {
        style: 2 | 1;
        time: boolean;
        noChangeRotate: boolean;
    };
    constructor(props: Props);
    getShowViewArr(rotate: ICommonInterface["rotate"]): ("fadeIn" | "fadeOut")[];
    changeBasicState: <K extends keyof States>(key: K, callback: (states: States) => States[K], obj?: {
        showTimeObj: ICommonInterface['curTime'];
        viewIndex: number;
    } | undefined) => boolean | undefined;
    createFixProps(): {
        style: 2 | 1;
        time: boolean;
        noChangeRotate: boolean;
    };
    documentClickFn: () => void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    drop(): JSX.Element;
    renderCalendar(): JSX.Element;
    render(): JSX.Element;
}
export { Calendar };
