import * as React from "react";
import { IImmutalbeList } from "../util/immutableUtil";
declare type props<T extends AnyObj> = {
    dataSet?: string;
    disabled?: boolean;
    upBtn?: React.ReactChild;
    hasFiles?: T[];
    noRemove?: boolean;
    hasFilesTextField?: string;
    hasFilesIdField?: string;
    hasFilesUrlField?: string;
    name?: string;
    multiply?: boolean;
    className?: string;
    norequire?: boolean;
    fileTypeMatch?: string;
    children?: React.ReactNode;
    changeFn?: (files: states<T>["upFiles"], name: string | undefined, dataSet?: string) => void;
    removeFIleFn?: (files: states<T>["upFiles"], name: string | undefined, type: string) => void;
    bindGetUpAndHasFiles?: (fn: () => {
        upFiles: File[];
        hasFile: T[];
    }) => void;
};
declare type states<T extends AnyObj> = {
    upFiles: IImmutalbeList<{
        id: number;
        file: File;
    }>;
    hasFile: IImmutalbeList<T>;
    preHasFiles: props<T>["hasFiles"];
};
interface IInput {
    getInpTit(): JSX.Element | "";
}
declare class FileInp<T extends AnyObj> extends React.PureComponent<props<T>, states<T>> implements IInput {
    static defaultProps: {
        styleName: string;
        hasFilesTextField: string;
        hasFilesIdField: string;
        hasFilesUrlField: string;
    };
    static getDerivedStateFromProps(nextProps: props<AnyObj>, preState: states<AnyObj>): Partial<states<AnyObj>> | null;
    constructor(prop: props<T>);
    getFiles: () => {
        upFiles: File[];
        hasFile: T[];
    };
    getInpTit(): JSX.Element | "";
    changeFn: (e: React.ChangeEvent<HTMLInputElement>) => void;
    removeFileItem: (e: React.MouseEvent<HTMLSpanElement>) => void;
    getHasFile(): JSX.Element;
    getUpFile(): JSX.Element;
    render(): JSX.Element;
}
export default FileInp;
