import * as React from "react";
import * as Immutable from "immutable";
import { IMenuData, IfieldObj, ILinkNode, treeNode } from "./menu";
import { IImmutalbeList } from "../util/immutableUtil";
import { IScrollMethods } from "../scroll/scroll";
declare type props = {
    data: IMenuData[];
    onlyOpenSelected?: boolean;
    width?: number;
    expand: boolean;
    textField?: string;
    idField?: string;
    urlField?: string;
    iconField?: string;
    defaultMenuId?: string;
    formatterItem?: (node: treeNode<IMenuData>) => React.ReactNode;
    init?: {
        id: string;
    };
    link?: (node: ILinkNode) => JSX.Element;
    children?: React.ReactNode;
    clickBack?: (node: AnyObj) => void;
};
declare type states = {
    selected: string;
    immutableData: IImmutalbeList<treeNode<IMenuData>>;
    fieldObj: IfieldObj;
    preData: AnyObj[];
    preInit: {
        id: string;
    } | undefined;
};
interface INavMenu {
    initState(prop: props): states;
    getParMenu(): Immutable.List<JSX.Element>;
    changeImmutableData(callback: (data: states["immutableData"], selected: string) => {
        data: states["immutableData"];
        selected: string;
    }): void;
}
declare class NavMenu extends React.PureComponent<props, states> implements INavMenu {
    static defaultProps: {
        textField: string;
        idField: string;
        iconField: string;
        urlField: string;
        width: number;
    };
    static getDerivedStateFromProps(nextProps: props, preState: states): Partial<states> | null;
    scrollBoxMethod: IScrollMethods | undefined;
    bindScrollboxFn: (method?: IScrollMethods | undefined) => void;
    constructor(prop: props);
    initState(prop: props): {
        selected: string;
        immutableData: any;
        fieldObj: import("../util/immutableUtil").IImmutalbeMap<{
            id: string;
            text: string;
            url: string;
            icon: string;
        }, {
            id: string;
            text: string;
            url: string;
            icon: string;
        }>;
        preData: IMenuData[];
        preInit: {
            id: string;
        } | undefined;
    };
    toggleSlide: (index: number) => void;
    componentDidUpdate(preProps: props): void;
    getParMenu(): Immutable.List<JSX.Element>;
    changeImmutableData: (callback: (data: states["immutableData"], selected: string) => {
        data: states["immutableData"];
        selected: string;
    }) => void;
    render(): JSX.Element;
}
export default NavMenu;
