import * as React from "react";
import * as Immutable from "immutable";
import { IMenuData, IfieldObj, ILinkNode, treeNode } from "./menu";
import { IImmutalbeList } from "../util/immutableUtil";
import { IScrollMethods } from "../scroll/scroll";
declare type props = {
    node: treeNode<IMenuData>;
    formatterItem?: (node: props["node"]) => React.ReactNode;
    expand: boolean;
    fieldObj: IfieldObj;
    link?: (node: ILinkNode) => JSX.Element;
    parIndex: number;
    toggleSlide: (index: number) => void;
    scrollInitFn?: IScrollMethods;
    changeData(callback: (data: IImmutalbeList<treeNode<IMenuData>>, selected: string) => {
        data: IImmutalbeList<treeNode<IMenuData>>;
        selected: string;
    }): void;
};
declare type states = {};
interface IParMenu {
    subMenu(children: Immutable.List<treeNode<IMenuData>>, parIndex: number): Immutable.List<JSX.Element>;
    getSubCom(): JSX.Element;
}
declare class ParMenu extends React.PureComponent<props, states> implements IParMenu {
    state: states;
    selectItemFn: (e: React.MouseEvent<HTMLSpanElement>) => void;
    subMenu(children: Immutable.List<treeNode<IMenuData>>, parIndex: number): Immutable.List<JSX.Element>;
    slideCallback: (isStart?: boolean | undefined) => void;
    getSubCom(): JSX.Element;
    toggleSlide: () => void;
    renderPar(): JSX.Element;
    renderSingleNav(): JSX.Element;
    render(): JSX.Element;
}
export default ParMenu;
