import { IImmutalbeMap, IImmutalbeList } from "../../util/immutableUtil";
export interface Inode {
    checked: boolean;
    selected: boolean;
}
export interface IColumnItem<T> {
    field: string;
    width?: number | string;
    isRowSpanField?: boolean;
    align?: string;
    formatter?: (node: IImmutalbeMap<Inode & T>, index: string, tabField: string | undefined, field: string) => React.ReactChild;
}
export declare type fieldObj<T> = {
    column: IColumnItem<T>[];
    idField: string;
    noOrder?: boolean;
    checkbox?: boolean;
    tabField?: string;
    noPageNums?: boolean;
    canSelectField: string;
};
export interface ITableStates<T> {
    perNums: number;
    curPage: number;
    tableData: IImmutalbeList<IImmutalbeMap<Inode & T>>;
    preData: T[];
    preInitSelectVal?: {
        id: string;
    };
    curOptId: string;
}
export interface ITableFn<T> {
    changeState<P extends keyof ITableStates<T>>(field: P, data: ITableStates<T>[P]): void;
}
