import * as React from "react";
import { GroupCols } from "./GroupCols";
import { ICommon, Inode } from "./mytablist";
import { IImmutalbeMap, IImmutalbeList } from "../../util/immutableUtil";
import { IScrollMethods } from "../../scroll/scroll";
declare type childType<T> = React.ComponentElement<ICommon<T>["groupCol"], React.ComponentState>;
declare type Props<T> = {
    data: T[];
    children: childType<T>[] | childType<T>;
    originScroll?: boolean;
    slectField?: string;
    height?: number;
    tabStyle?: "stripe";
    noOrder?: boolean;
    noPageNums?: boolean;
    idField: string;
    multiply?: boolean;
    defaultSel?: string;
    tabField?: string;
    emptyTxt?: string | ((tabField?: string) => React.ReactChild);
    initSelectVal?: {
        id: string;
    };
    bindGetSelectedFn?: (getSelected: () => IImmutalbeList<IImmutalbeMap<Inode & T>>) => void;
};
declare type States<T> = {
    immutabData: IImmutalbeList<IImmutalbeMap<Inode & T>>;
    selectArr: IImmutalbeList<string>;
    perNums: number;
    curPage: number;
    tableData: IImmutalbeList<IImmutalbeMap<Inode & T>>;
    preData: T[];
    preInitSelect?: {
        id: string;
    };
    isreLoad: AnyObj;
    oldSlected: number;
};
declare type config<T> = ICommon<T>["config"];
interface ITabList<T> {
    fieldArr: config<T>[];
    fixObj: ICommon<T>["fixObj"];
}
declare class TabList<T extends AnyObj> extends React.PureComponent<Props<T>, States<T>> implements ITabList<T> {
    static defaultProps: {};
    static getDerivedStateFromProps(nextProps: Props<AnyObj>, preState: States<AnyObj>): Partial<States<AnyObj>> | null;
    fieldArr: ITabList<T>["fieldArr"];
    fixObj: ITabList<T>["fixObj"];
    tabMainTabBodyDomArr: HTMLDivElement[];
    tabMainTabBodyScrollFnArr: (IScrollMethods | undefined)[];
    preFieldArr: ITabList<T>["fieldArr"];
    constructor(props: Props<T>);
    shouldComponentUpdate(nextProps: Readonly<Props<T>>): boolean;
    getDataByPageAndPerNum(curPage: number, perNums: number, immutabData: States<T>["immutabData"]): IImmutalbeList<IImmutalbeMap<Inode & T, Inode & T>>;
    getFieldArr(props: Props<T>): {
        child: (Omit<import("./mytablist").IColumnItem<T>, "children"> & {
            text: React.ReactNode;
        })[];
        width: number;
        forzen: boolean | undefined;
    }[];
    initFixObj(): {
        tabField: string;
        emptyTxt: string | ((tabField?: string | undefined) => React.ReactChild);
        idField: string;
        multiply: boolean | undefined;
        noOrder: boolean | undefined;
        defaultSel: string;
        slectField: string | undefined;
    };
    setTabBodyDom: (dom: HTMLDivElement, index: number, scrollBoxFn?: IScrollMethods | undefined) => void;
    changeScrollTop: (top: number, index: number) => void;
    changeState: ICommon<T>["changeState"];
    setSameH(): void;
    setDom(): void;
    viewMap(): JSX.Element[];
    componentDidMount(): void;
    componentDidUpdate(preProps: Props<T>): void;
    setTabViewBottomFixHeight(): void;
    changePageHandle: (key: "curPage" | "perNums", val: number) => void;
    render(): JSX.Element;
}
export { TabList, GroupCols };
