import * as React from "react";
import { ICommon } from "./mytreeTable";
import { IScrollMethods } from "../../scroll/scroll";
declare type Props<T extends AnyObj> = {
    data: ICommon<T>["data"];
    config: ICommon<T>["config"];
    fixObj: ICommon<T>["fixObj"];
    viewIndex: number;
    originScroll?: boolean;
    theadChild: ICommon<T>["groupCol"]["children"];
    changeState: ICommon<T>["changeState"];
    setTabBodyDom(dom: HTMLElement, viewIndex: number, scrollFn?: IScrollMethods): void;
    changeScrollTop(top: number, viewIndex: number): void;
    isreLoad: AnyObj;
    totalView: number;
    noAimate?: {
        init: boolean;
    };
};
declare type States = {};
interface ITabView {
    getBody(): JSX.Element;
}
declare class TabView<T extends AnyObj> extends React.PureComponent<Props<T>, States> implements ITabView {
    colHeadRef: React.RefObject<HTMLDivElement>;
    tabBodyRef: React.RefObject<HTMLDivElement>;
    state: States;
    overBoxTimer: number;
    scrollBoxMethod: IScrollMethods | undefined;
    bindScrollboxFn: (method?: IScrollMethods | undefined) => void;
    originScrollFn: (e: React.UIEvent<HTMLDivElement>) => void;
    gethead(): JSX.Element;
    createColgroup(): JSX.Element;
    componentDidMount(): void;
    componentDidUpdate(preProps: Props<T>): void;
    componentWillUnmount(): void;
    overBox(): void;
    wheelFn: (e: WheelEvent) => void;
    makeSign: (e: React.MouseEvent<HTMLDivElement>) => void;
    scrollInitOnslideAfter: () => void;
    getBody(): JSX.Element;
    scrollCallback: (value: number, isVertical: boolean) => void;
    render(): JSX.Element;
}
export default TabView;
